Index: arch/ia64/src/ski/ski.c
===================================================================
--- arch/ia64/src/ski/ski.c	(revision 91c78c9c94e66242e7a59d1070420b5347b9eaee)
+++ arch/ia64/src/ski/ski.c	(revision adb2ebf8ae233e612225d6bd9fe2229d2b8e4d67)
@@ -34,5 +34,5 @@
 static bool kb_disable;
 
-static void ski_write(chardev_t *d, const char ch);
+static void ski_putchar(chardev_t *d, const char ch);
 static __s32 ski_getchar(void);
 
@@ -45,5 +45,5 @@
  * @param ch Character to be printed.
  */
-void ski_write(chardev_t *d, const char ch)
+void ski_putchar(chardev_t *d, const char ch)
 {
 	__asm__ (
@@ -57,5 +57,5 @@
 	
 	if (ch == '\n')
-		ski_write(d, '\r');
+		ski_putchar(d, '\r');
 }
 
@@ -117,5 +117,5 @@
 	.resume = ski_kb_enable,
 	.suspend = ski_kb_disable,
-	.write = ski_write
+	.write = ski_putchar
 };
 
Index: arch/ppc32/include/console.h
===================================================================
--- arch/ppc32/include/console.h	(revision adb2ebf8ae233e612225d6bd9fe2229d2b8e4d67)
+++ arch/ppc32/include/console.h	(revision adb2ebf8ae233e612225d6bd9fe2229d2b8e4d67)
@@ -0,0 +1,34 @@
+/*
+ * Copyright (C) 2005 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef __ppc32_CONSOLE_H__
+#define __ppc32_CONSOLE_H__
+
+extern void ofw_ppc32_console_init(void);
+
+#endif
Index: arch/ppc32/src/console.c
===================================================================
--- arch/ppc32/src/console.c	(revision 91c78c9c94e66242e7a59d1070420b5347b9eaee)
+++ arch/ppc32/src/console.c	(revision adb2ebf8ae233e612225d6bd9fe2229d2b8e4d67)
@@ -27,5 +27,5 @@
  */
 
-#include <putchar.h>
+#include <arch/console.h>
 #include <genarch/ofw/ofw.h>
 #include <console/chardev.h>
@@ -36,18 +36,18 @@
  * @param ch Character to be printed.
  */
-static void ofw_write(chardev_t *d, const char ch)
+static void ofw_ppc32_putchar(chardev_t *d, const char ch)
 {
 	ofw_putchar(ch);
 }
 
-chardev_t ofw_console;
-static chardev_operations_t ofw_ops = {
-	.write = ofw_write
+static chardev_t ofw_ppc32_console;
+static chardev_operations_t ofw_ppc32_console_ops = {
+	.write = ofw_ppc32_putchar
 };
 
 /** Initialize console to use ofw output */
-void console_init(void)
+void ofw_ppc32_console_init(void)
 {
-	chardev_initialize("ofw_out", &ofw_console, &ofw_ops);
-	stdout = &ofw_console;
+	chardev_initialize("ofw_out", &ofw_ppc32_console, &ofw_ppc32_console_ops);
+	stdout = &ofw_ppc32_console;
 }
Index: arch/ppc32/src/ppc32.c
===================================================================
--- arch/ppc32/src/ppc32.c	(revision 91c78c9c94e66242e7a59d1070420b5347b9eaee)
+++ arch/ppc32/src/ppc32.c	(revision adb2ebf8ae233e612225d6bd9fe2229d2b8e4d67)
@@ -28,7 +28,9 @@
 
 #include <arch.h>
+#include <arch/console.h>
 
 void arch_pre_mm_init(void)
 {
+	ofw_ppc32_console_init();
 }
 
Index: arch/sparc64/include/console.h
===================================================================
--- arch/sparc64/include/console.h	(revision adb2ebf8ae233e612225d6bd9fe2229d2b8e4d67)
+++ arch/sparc64/include/console.h	(revision adb2ebf8ae233e612225d6bd9fe2229d2b8e4d67)
@@ -0,0 +1,34 @@
+/*
+ * Copyright (C) 2005 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef __sparc64_CONSOLE_H__
+#define __sparc64_CONSOLE_H__
+
+extern void ofw_sparc64_console_init(void);
+
+#endif
Index: arch/sparc64/src/console.c
===================================================================
--- arch/sparc64/src/console.c	(revision 91c78c9c94e66242e7a59d1070420b5347b9eaee)
+++ arch/sparc64/src/console.c	(revision adb2ebf8ae233e612225d6bd9fe2229d2b8e4d67)
@@ -27,6 +27,21 @@
  */
 
-#include <putchar.h>
+#include <arch/console.h>
 #include <genarch/ofw/ofw.h>
+#include <console/chardev.h>
+#include <console/console.h>
+
+static void ofw_sparc64_putchar(chardev_t *d, const char ch);
+
+static chardev_t ofw_sparc64_console;
+static chardev_operations_t ofw_sparc64_console_ops = {
+	.write = ofw_sparc64_putchar
+};
+
+void ofw_sparc64_console_init(void)
+{
+	chardev_initialize("ofw_sparc64_console", &ofw_sparc64_console, &ofw_sparc64_console_ops);
+	stdout = &ofw_sparc64_console;
+}
 
 /** Print one character.
@@ -34,5 +49,5 @@
  * @param ch Character to be printed.
  */
-void putchar(const char ch)
+void ofw_sparc64_putchar(chardev_t *d, const char ch)
 {
 	if (ch == '\n')
Index: arch/sparc64/src/sparc64.c
===================================================================
--- arch/sparc64/src/sparc64.c	(revision 91c78c9c94e66242e7a59d1070420b5347b9eaee)
+++ arch/sparc64/src/sparc64.c	(revision adb2ebf8ae233e612225d6bd9fe2229d2b8e4d67)
@@ -32,7 +32,9 @@
 #include <memstr.h>
 #include <arch/trap_table.h>
+#include <arch/console.h>
 
 void arch_pre_mm_init(void)
 {
+	ofw_sparc64_console_init();
 }
 
Index: generic/include/console/chardev.h
===================================================================
--- generic/include/console/chardev.h	(revision 91c78c9c94e66242e7a59d1070420b5347b9eaee)
+++ generic/include/console/chardev.h	(revision adb2ebf8ae233e612225d6bd9fe2229d2b8e4d67)
@@ -37,12 +37,9 @@
 #define CHARDEV_BUFLEN 512
 
-struct chardev;
-
 /* Character device operations interface. */
 struct chardev_operations {
-	void (* suspend)(struct chardev *);/**< Suspend pushing characters. */
-	void (* resume)(struct chardev *); /**< Resume pushing characters. */
-	/** Write character to stream */
-	void (* write)(struct chardev *, char c);
+	void (* suspend)(chardev_t *);		/**< Suspend pushing characters. */
+	void (* resume)(chardev_t *); 		/**< Resume pushing characters. */
+	void (* write)(chardev_t *, char c);	/**< Write character to stream. */
 };
 
Index: generic/include/interrupt.h
===================================================================
--- generic/include/interrupt.h	(revision 91c78c9c94e66242e7a59d1070420b5347b9eaee)
+++ generic/include/interrupt.h	(revision adb2ebf8ae233e612225d6bd9fe2229d2b8e4d67)
@@ -33,5 +33,5 @@
 
 #ifndef IVT_ITEMS
-#  define IVT_ITEMS 1
+#  define IVT_ITEMS 0
 #endif
 
Index: generic/src/interrupt/interrupt.c
===================================================================
--- generic/src/interrupt/interrupt.c	(revision 91c78c9c94e66242e7a59d1070420b5347b9eaee)
+++ generic/src/interrupt/interrupt.c	(revision adb2ebf8ae233e612225d6bd9fe2229d2b8e4d67)
@@ -113,5 +113,5 @@
 static cmd_info_t exc_info = {
 	.name = "pexc",
-	.description = "Print exception table",
+	.description = "Print exception table.",
 	.func = exc_print_cmd,
 	.help = NULL,
